moSetGetMapObjects = {};

function moSetGetMapObjects:searchFirstMapObjects(self)	
	moMapObjects = {};
	moMapObjects.fs = {};
	moMapObjects.sr = {};
	moMapObjects.ls = {};
	moMapObjects.vm = {};
	moMapObjects.upk = {};
	moMapObjects.other = {};
	moMapObjects.palSammler = {};	
	moMapObjects.watermod = {};	
	--moMapShops = {};	
	moBgaMapObjects = {};
	moBgaMapObjects.silo = 0;
	moBgaMapObjects.catcher = 0;
	moBgaMapObjects.bgaExtension = false;
	moBgaMapObjects.silageExtension = false;
	if moMapTrigger == nil then moMapTrigger = {};end;
	local fs = 0;
	local vm = 0;
	local ls = 0;
	local sr = 0;
	local upk = 0;
	local other = 0;
	local palSammler = 0;
	local maxAnimals = 5;
	local farmSilo = moGeneralSettings.multiFarmSilo;	
	if g_currentMission.onCreateLoadedObjects ~= nil then		
		for k, onCreateObject in pairs(g_currentMission.onCreateLoadedObjects) do
			if onCreateObject.multiSiloTriggerDirtyFlag then --load
				local stationName = onCreateObject.stationName;						
				if stationName ~= nil then							
					if stationName == "Hofsilo" or stationName == "HofSiloLoad01" then
						local fillTypes = getUserAttribute(onCreateObject.rootNode, "fillTypes");									
						if fillTypes == nil then
							fillTypes = getUserAttribute(onCreateObject.rootNode, "fruitTypes");
						end;
						if string.len(moGeneralSettings.multiFarmSiloLoad) > 1 then
							moGeneralSettings.multiFarmSiloLoad = moGeneralSettings.multiFarmSiloLoad.. " ";
						else
							moGeneralSettings.multiFarmSiloLoad = fillTypes.. " ";
						end;
						local fillTypesSplit = Utils.splitString(" ", moGeneralSettings.multiFarmSiloLoad);		
						for _,v in pairs(fillTypesSplit) do
							local toInt = Fillable.fillTypeNameToInt[v];					
							if toInt ~= nil and onCreateObject.fillTypes[toInt] == nil then
								moFillTypes[toInt].siloLoad[farmSilo] = true;
								if not MultiOverlayV2.isMp then
									onCreateObject.fillTypes[toInt] = toInt;
								end;
							elseif toInt ~= nil then
								moFillTypes[toInt].siloLoad[farmSilo] = true;								
							end;					
						end;						
						moMapTrigger["hofSiloLoad"] = onCreateObject;
					end;
				end;
			end;
			if moGeneralSettings.upkReady and onCreateObject.base then
				upk = upk+1;
				local upkName = "factory";
				moMapObjects.upk[upk] = onCreateObject.base;
				local x,y,z = getWorldTranslation(onCreateObject.base.rootNode);
				moMapObjects.upk[upk].x = x;
				moMapObjects.upk[upk].z = z;
				moMapObjects.upk[upk].y = y;
				if onCreateObject.base.name ~= nil then
					upkName = string.lower(onCreateObject.base.name);
				end;
				moMapObjects.upk[upk].name = upkName;
				moGeneralSettings.foundUpk = moGeneralSettings.foundUpk.. "MapName(xmlModString):".. tostring(upkName).. " ";
			end;
			--if onCreateObject.fremdObject ~= nil and onCreateObject.Points ~= nil then				
				if onCreateObject.WoolPaletteCollectorDirtyFlag then
					moGeneralSettings.wollPalCollector = true;
					palSammler = palSammler+1;
					moMapObjects.palSammler[palSammler] = onCreateObject;					
					--if onCreateObject.Points ~= nil and onCreateObject.Points[0] ~= nil and onCreateObject.Points[0].node ~= nil then	--old node2					
					if onCreateObject.nodeID ~= nil then						
						local x,y,z = getWorldTranslation(onCreateObject.nodeID);	--onCreateObject.Points[0].node					
						moMapObjects.palSammler[palSammler].palX = tonumber(math.floor(x + .5));
						moMapObjects.palSammler[palSammler].palY = tonumber(math.floor(y + .5));
						moMapObjects.palSammler[palSammler].palZ = tonumber(math.floor(z + .5));						
					end;										
				end;
				if onCreateObject.PalettenSammlerDirtyFlag then					
					moGeneralSettings.palSammler = true;
					palSammler = palSammler+1;
					moMapObjects.palSammler[palSammler] = onCreateObject;
					--if onCreateObject.palletSpawnerPlaceId ~= nil then		--self.Points[0].node = self.palletSpawnerPlaceId;	onCreateObject.palletSpawnerPlaceId	
					if onCreateObject.nodeID ~= nil then
						local x,y,z = getWorldTranslation(onCreateObject.nodeID);		--onCreateObject.palletSpawnerPlaceId																
						moMapObjects.palSammler[palSammler].palX = tonumber(math.floor(x + .5));
						moMapObjects.palSammler[palSammler].palY = tonumber(math.floor(y + .5));
						moMapObjects.palSammler[palSammler].palZ = tonumber(math.floor(z + .5));						
					end;
				end;
			--end;
			if not moGeneralSettings.watermod and onCreateObject.Needs ~= nil then				
				moGeneralSettings.watermod = true;
				--moMapObjects.watermod = onCreateObject.Needs
				for kk, v in pairs(onCreateObject.Needs) do
					moMapObjects.watermod[kk] = {};					
					local a = 0;
					for k1, v1 in pairs(onCreateObject.Needs[kk]) do
						a = a+1;
						moMapObjects.watermod[kk][a] = k1;						
					end;
					moMapObjects.watermod[kk].length = a;					
				end;				
			end;			
			if onCreateObject.improvedSilageBunkerInitDone ~= nil and not moBgaMapObjects.silageExtension then
				moBgaMapObjects.silageExtension = true;								
			end;
			if onCreateObject.MischStationDirtyFlag and onCreateObject.name ~= nil then
				moGeneralSettings.mischStation = true;
				local otherName = "other";					
				other = other+1;
				onCreateObject.otherType = "mischstation";
				moMapObjects.other[other] = onCreateObject;
				moMapObjects.other[other].name = string.lower(string.gsub(onCreateObject.name, " ", ""));
				if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
					local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
					if mapFactoryName ~= nil and mapFactoryName ~= false then
						moMapObjects.other[other].name = mapFactoryName;
						if otherName == "other" then otherName = "(Slot factor1 - MapName(xmlModString):".. mapFactoryName.. ")";end;
						moMapObjects.other[other].userAttribut = true;
					end;						
				end;
				if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.nodeId);
					moMapObjects.other[other].x = x;
					moMapObjects.other[other].z = z;
					moMapObjects.other[other].y = y;
				end;
				if otherName == "other" then otherName = "(Slot factory1 - MapName(xmlModString):".. moMapObjects.other[other].name.. ")";end;	
				moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring(otherName).. " ";
			end;
			if onCreateObject.FermentingSiloDirtyFlag and onCreateObject.name ~= nil then
				moGeneralSettings.fermentingSilo = true;
				local otherName = "other";					
				other = other+1;
				onCreateObject.otherType = "fermentingsilo";
				moMapObjects.other[other] = onCreateObject;
				moMapObjects.other[other].name = string.lower(string.gsub(onCreateObject.name, " ", ""));
				if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
					local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
					if mapFactoryName ~= nil and mapFactoryName ~= false then
						moMapObjects.other[other].name = mapFactoryName;
						if otherName == "other" then otherName = "(Slot factor1 - MapName(xmlModString):".. mapFactoryName.. ")";end;
						moMapObjects.other[other].userAttribut = true;
					end;						
				end;
				if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.nodeId);
					moMapObjects.other[other].x = x;
					moMapObjects.other[other].z = z;
					moMapObjects.other[other].y = y;
				end;
				if otherName == "other" then otherName = "(Slot factory1 - MapName(xmlModString):".. moMapObjects.other[other].name.. ")";end;	
				moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring(otherName).. " ";
			end;
			if onCreateObject.FabrikScriptDirtyFlag then
				if not onCreateObject.FabrikScriptDirtyFlag then ---old others
					local otherName = "other";					
					other = other+1;						
					moMapObjects.other[other] = onCreateObject;
					moMapObjects.other[other].name = otherName;
					if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
						local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
						if mapFactoryName ~= nil and mapFactoryName ~= false then
							moMapObjects.other[other].name = mapFactoryName;
							if otherName == "other" then otherName = "other(Slot factor1 - MapName(xmlModString):".. mapFactoryName.. ")";end;
							moMapObjects.other[other].userAttribut = true;
						end;						
					end;					
					if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
						local x,y,z = getWorldTranslation(onCreateObject.nodeId);
						moMapObjects.other[other].x = x;
						moMapObjects.other[other].z = z;
						moMapObjects.other[other].y = y;
					end;
					local removeOther = false;
					if otherName == "other" then
						otherName = string.lower(string.gsub(onCreateObject.name, " ", ""));
						if string.find(otherName, "mischstation") then otherName = "mischstation";end;					
						if string.find(moObjectsDefault.acceptOther, otherName.. " ") then
							moMapObjects.other[other].name = otherName;							
						else
							table.remove(moMapObjects.other[other]);
							other = other-1;
							removeOther = true;
						end;						
					end;
					if not removeOther then moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring(otherName).. " ";end;
				else
					moGeneralSettings.fabrikscript = true;
					fs = fs+1;
					moMapObjects.fs[fs] = onCreateObject;
					if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
						local x,y,z = getWorldTranslation(onCreateObject.nodeId);
						moMapObjects.fs[fs].x = x;
						moMapObjects.fs[fs].z = z;
						moMapObjects.fs[fs].y = y;
					end;
					local otherName = "factory";					
					local OutputIndex = getUserAttribute(onCreateObject.nodeId, "outputIndex");
					if OutputIndex then
						local OutputId = Utils.indexToObject(onCreateObject.nodeId, OutputIndex);	
						if OutputId then
							local numChildren = getNumOfChildren(OutputId);
							local a = 0;
							for i = 1, numChildren do
								local produktId = getChildAt(OutputId,i-1);
								local palletSpawnerId = getChild(produktId,"palletSpawner");
								if palletSpawnerId and palletSpawnerId ~= 0 then
									local spawnerPlaceId = getChildAt(palletSpawnerId, 1);
									a = a+1;
									local palX,palY,palZ = getWorldTranslation(spawnerPlaceId);							
									if moMapObjects.fs[fs].palXYZ == nil then moMapObjects.fs[fs].palXYZ = {};end;
									moMapObjects.fs[fs].palXYZ[a] = {tonumber(math.floor(palX + .5)), tonumber(math.floor(palY + .5)), tonumber(math.floor(palZ + .5))};	
								end;
							end;
						end;						
					end;
					
					
					--if onCreateObject.Produkte ~= nil then
					--	local a = 0;
					--	for k1, v in pairs(onCreateObject.Produkte) do
							--if onCreateObject.Produkte[k] ~= nil and onCreateObject.Produkte[k].palletSpawner ~= nil and onCreateObject.Produkte[k].palletSpawner.SpawnerPlaceId ~= nil then	--PalletTrigger							
					--		print(tostring(MultiOverlayV2:tableToString(onCreateObject.Produkte[k1])))
					--		if onCreateObject.Produkte[k1] ~= nil and onCreateObject.Produkte[k1].palletSpawner ~= nil then --palletSpawner.SpawnerTriggerId
								
								--a = a+1;
								--local palX,palY,palZ = getWorldTranslation(onCreateObject.Produkte[k].palletSpawner.SpawnerPlaceId);							
								--if moMapObjects.fs[fs].palXYZ == nil then moMapObjects.fs[fs].palXYZ = {};end;
								--moMapObjects.fs[fs].palXYZ[a] = {tonumber(math.floor(palX + .5)), tonumber(math.floor(palY + .5)), tonumber(math.floor(palZ + .5))};								
					--		end;
					--	end;
					--end;									
					moMapObjects.fs[fs].name = otherName;					
					if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
						local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
						if mapFactoryName ~= nil and mapFactoryName ~= false then
							moMapObjects.fs[fs].name = mapFactoryName;
							if otherName == "factory" then otherName = "(Slot other1 - MapName(xmlModString):".. mapFactoryName.. ")";end;
							moMapObjects.fs[fs].userAttribut = true;
						end;					
					end;
					if otherName == "factory" then otherName = "(Slot other1)";end;
					moGeneralSettings.foundFabrikscript = moGeneralSettings.foundFabrikscript.. tostring(otherName).. " ";
				end;				
			end;			
			--if onCreateObject.FabrikScriptDirtyFlag ~= nil and not foundName then				
				--fs = fs+1;
				--moGeneralSettings.fabrikscript = true;
				--moDefaultPlaceableObjects.mapObjectsFsSearch = moDefaultPlaceableObjects.mapObjectsFsSearch+1;
				--moDefaultPlaceableObjects.mapObjectsFsStatus[fs] = onCreateObject;
				--moDefaultPlaceableObjects.mapObjectsFsName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				--moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				--local modName = getUserAttribute(onCreateObject.nodeId, "onCreate"); --factoryName
				--if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
				--	local factoryName = Utils.getNoNil(getUserAttribute(onCreateObject.nodeId, "factoryName"), false); --factoryName				
				--	if factoryName ~= nil and factoryName ~= false then
				--		moDefaultPlaceableObjects.mapObjectsFsName[fs] = string.lower(factoryName);	
				--		moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = factoryName;						
				--	end;
				--end;
			--end;
			if onCreateObject.gasTriggerDirtyFlag ~= nil then
				moGeneralSettings.gasStation = true;			
			end;
			if onCreateObject.siloTriggerfillDoneDirtyFlag ~= nil then
				moGeneralSettings.allInOnSilo = true;				
			end;			
			if onCreateObject.stationName == "BunkerSilo" and onCreateObject.bunkerSilo then				
				moBgaMapObjects.silo = moBgaMapObjects.silo+1
				moBgaMapObjects["silo".. moBgaMapObjects.silo] = {};
				moBgaMapObjects["silo".. moBgaMapObjects.silo].obj = onCreateObject.bunkerSilo;
				moBgaMapObjects["silo".. moBgaMapObjects.silo].objCreate = onCreateObject;
				if getUserAttribute ~= nil and onCreateObject.bunkerSilo.nodeId ~= nil then
					local silageSiloName = Utils.getNoNil(getUserAttribute(onCreateObject.bunkerSilo.nodeId, "silageSiloName"), nil); --factoryName
					if silageSiloName ~= nil then
						moBgaMapObjects["silo".. moBgaMapObjects.silo].siloName = silageSiloName;
						moBgaMapObjects["silo".. moBgaMapObjects.silo].userAttribut = true;
					end;
				end;
			end;
			if onCreateObject.bunkerUseTime and onCreateObject.bunkerFillLevel then
				moBgaMapObjects.catcher = moBgaMapObjects.catcher+1;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher] = {};
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = false;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].obj = onCreateObject.tipTriggers[1]; --g_currentMission.onCreateLoadedObjects[onCreateObject.id];
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].objCreate = onCreateObject;								
				if onCreateObject.fermenter_TS_clog or onCreateObject.BGA_Bonus ~= nil then					
					moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = true;
					moBgaMapObjects.bgaExtension = true;					
				end;								
			end;
			if onCreateObject.SchweineZuchtDirtyFlag ~= nil and onCreateObject.animal ~= nil then				
				sr = sr+1;
				local otherName = "animals";
				local animalName = string.lower(onCreateObject.animal);
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";				
				if string.find(moGeneralSettings.foundAnimalsLog, animalName) then
					for a=1, maxAnimals do
						if not string.find(moGeneralSettings.foundAnimalsLog, animalName.. "_".. a) then
							animalName = animalName.. "_".. a;							
							break;
						end;
					end;				
				end;
				moMapObjects.sr[sr] = onCreateObject;
				moMapObjects.sr[sr].name = animalName;
				if onCreateObject.tipTriggers[1] ~= nil and onCreateObject.tipTriggers[1].rootNode ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
					moMapObjects.sr[sr].x = x;
					moMapObjects.sr[sr].z = z;	
				end;				
				if onCreateObject.palletSpawnerId ~= nil then
					local palX,palY,palZ = getWorldTranslation(onCreateObject.palletSpawnerId);																		
					moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
					moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
					moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
				end;
				if otherName == "animals" then otherName = "(Slot animals - MapName(xmlModString):".. moMapObjects.sr[sr].name.. ")";moMapObjects.sr[sr].userAttribut = true;end;	
				moGeneralSettings.foundAnimalsLog = moGeneralSettings.foundAnimalsLog.. tostring(otherName).. " ";
			end;
			if onCreateObject.HaseZuchtDirtyFlag ~= nil and onCreateObject.animal ~= nil then
				sr = sr+1;
				local otherName = "animals";
				local animalName = string.lower(onCreateObject.animal);
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
				if string.find(moGeneralSettings.foundAnimalsLog, animalName) then
					for a=1, maxAnimals do
						if not string.find(moGeneralSettings.foundAnimalsLog, animalName.. "_".. a) then
							animalName = animalName.. "_".. a;							
							break;
						end;
					end;				
				end;
				moMapObjects.sr[sr] = onCreateObject;
				moMapObjects.sr[sr].name = animalName;				
				if onCreateObject.tipTriggers[1] ~= nil and onCreateObject.tipTriggers[1].rootNode ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
					moMapObjects.sr[sr].x = x;
					moMapObjects.sr[sr].z = z;	
				end;				
				if onCreateObject.palletSpawnerId ~= nil then
					local palX,palY,palZ = getWorldTranslation(onCreateObject.palletSpawnerId);																		
					moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
					moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
					moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
				end;
				if otherName == "animals" then otherName = "(Slot animals - MapName(xmlModString):".. moMapObjects.sr[sr].name.. ")";moMapObjects.sr[sr].userAttribut = true;end;	
				moGeneralSettings.foundAnimalsLog = moGeneralSettings.foundAnimalsLog.. tostring(otherName).. " ";
			end;
			if onCreateObject.LammZuchtDirtyFlag ~= nil and onCreateObject.animal ~= nil then
				sr = sr+1;
				local otherName = "animals";
				local animalName = string.lower(onCreateObject.animal);
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
				if string.find(moGeneralSettings.foundAnimalsLog, animalName) then
					for a=1, maxAnimals do
						if not string.find(moGeneralSettings.foundAnimalsLog, animalName.. "_".. a) then
							animalName = animalName.. "_".. a;							
							break;
						end;
					end;				
				end;
				moMapObjects.sr[sr] = onCreateObject;
				moMapObjects.sr[sr].name = animalName;				
				if onCreateObject.tipTriggers[1] ~= nil and onCreateObject.tipTriggers[1].rootNode ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
					moMapObjects.sr[sr].x = x;
					moMapObjects.sr[sr].z = z;
				end;				
				if onCreateObject.palletSpawnerId ~= nil then
					local palX,palY,palZ = getWorldTranslation(onCreateObject.palletSpawnerId);																		
					moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
					moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
					moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
				end;
				if otherName == "animals" then otherName = "(Slot animals - MapName(xmlModString):".. moMapObjects.sr[sr].name.. ")";moMapObjects.sr[sr].userAttribut = true;end;	
				moGeneralSettings.foundAnimalsLog = moGeneralSettings.foundAnimalsLog.. tostring(otherName).. " ";
			end;
			if onCreateObject.ViehMarktDirtyFlag ~= nil then				
				if (onCreateObject.fillTypes ~= nil and onCreateObject.priceMultipliers ~= nil) then --old Version Viehmarkt					
					moGeneralSettings.viehmarkt = true;
					vm = vm+1;
					moMapObjects.vm[vm] = onCreateObject;
				elseif (onCreateObject.AnimalTrigger.fillTypes ~= nil and onCreateObject.AnimalTrigger.priceMultipliers ~= nil) then --new Version Viehmarkt
					moGeneralSettings.viehmarkt = true;
					vm = vm+1;
					moMapObjects.vm[vm] = onCreateObject.AnimalTrigger;					
				end;
				if moGeneralSettings.viehmarkt then			
					if onCreateObject.AnimalTrigger.rootNode ~= nil and getWorldTranslation ~= nil then
						local x,y,z = getWorldTranslation(onCreateObject.AnimalTrigger.rootNode);
						moMapObjects.vm[vm].x = x;
						moMapObjects.vm[vm].z = z;
					end;
				end;
			end;			
			if onCreateObject.mixFeederDirtyFlag then				
				moGeneralSettings.mixFeeder = true;
				local otherName = "other";					
				other = other+1;
				onCreateObject.otherType = "mixfeeder";
				moMapObjects.other[other] = onCreateObject;
				moMapObjects.other[other].name = "MixFeeder";
				if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
					local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
					if mapFactoryName ~= nil and mapFactoryName ~= false then
						moMapObjects.other[other].name = mapFactoryName;
						if otherName == "other" then otherName = "(Slot factor1 - MapName(xmlModString):".. mapFactoryName.. ")";end;
						moMapObjects.other[other].userAttribut = true;
					end;						
				end;
				if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.nodeId);
					moMapObjects.other[other].x = x;
					moMapObjects.other[other].z = z;					
				end;
				if otherName == "other" then otherName = "(Slot factory1 - MapName(xmlModString):".. moMapObjects.other[other].name.. ")";end;	
				moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring(otherName).. " ";
			end;			
		end;
	end;
	if MapBuyableObject ~= nil then		
		moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("MapBuyableObject").. " ";
		if MapBuyableObject.masterTriggerAllowed == 1 and #MapBuyableObject.ObjectBuy.drawParts >= 1 then			
			moGeneralSettings.mapBuyableObject = true;				
		end;
	end;
	if g_currentMission.husbandries ~= nil then
		for k, v in pairs(g_currentMission.husbandries) do
			if tostring(k) == "sheep" or tostring(k) == "cow" or tostring(k) == "chicken" then
				ls = ls+1;
				moMapObjects.ls[ls] = v;				
				--local x,y,z;				
				--if tostring(k) ~= "chicken" then x,y,z = getWorldTranslation(g_currentMission.husbandries[k].tipTriggers[1].rootNode);moMapObjects.ls[ls].x=x;moMapObjects.ls[ls].z=z;end;				
				local animalName = string.lower(k)
				--if tostring(k) == "sheep" then print(tostring(MultiOverlayV2:tableToString(v)));end;
				if g_currentMission.husbandries[k] ~= nil and g_currentMission.husbandries[k].palletSpawnerId ~= nil then --g_currentMission.husbandries[k].palletSpawnerTriggerId
					local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[k].palletSpawnerId);																		
					moMapObjects.ls[ls].palX = tonumber(math.floor(palX + .5));
					moMapObjects.ls[ls].palY = tonumber(math.floor(palY + .5));
					moMapObjects.ls[ls].palZ = tonumber(math.floor(palZ + .5));					
				end;				
				moMapObjects.ls[ls].name = animalName;
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
				moMapObjects.ls[ls].userAttribut = true;
			--elseif v.animal ~= nil then
			--	sr = sr+1;
			--	local animalName = string.lower(v.animal);
			--	moMapObjects.sr[sr] = v;
			--	moMapObjects.sr[sr].name = animalName;
			--	local x,y,z = getWorldTranslation(v.tipTriggers[1].rootNode);
			--	moMapObjects.sr[sr].x = x;
			--	moMapObjects.sr[sr].z = z;				
			--	moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
			--	if g_currentMission.husbandries[animalName] ~= nil and g_currentMission.husbandries[animalName].palletSpawnerTriggerId ~= nil then
			--		local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[animalName].palletSpawnerTriggerId);																		
			--		moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
			--		moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
			--		moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
			--	end;
			end;
		end;
	end;
	local notFoundPalSammler = 0;
	if table.getn(moMapObjects.palSammler) > 0 then
		local foundPalSammler = 0;
		function checkSetPalSammler(mapObjectTable, mx, my, mz, k1)
			for k, palSammler in pairs(moMapObjects.palSammler) do
				if k ~= nil and palSammler.palX ~= nil and palSammler.palY ~= nil and palSammler.palZ ~= nil then
					local px = palSammler.palX;
					local py = palSammler.palY;
					local pz = palSammler.palZ;
					local distance = Utils.vector3Length(px-mx, py-my, pz-mz);
					if mx == px and mz == pz or distance <= 2 then --and mz == pz then
						if mapObjectTable.palSammler == nil then mapObjectTable.palSammler = {};end;
						mapObjectTable.palSammler[k1] = palSammler						
						foundPalSammler = foundPalSammler+1;
						break;						
					end;
				end;
			end;		
		end;
		if table.getn(moMapObjects.fs) > 0 and foundPalSammler < palSammler then
			for k, mapObject in pairs(moMapObjects.fs) do				
				if k ~= nil and mapObject.palXYZ ~= nil then
					for k1, mapObjectPal in pairs(mapObject.palXYZ) do
						if mapObjectPal ~= nil then
							local mx = mapObjectPal[1];
							local my = mapObjectPal[2];
							local mz = mapObjectPal[3];
							checkSetPalSammler(moMapObjects.fs[k], mx, my, mz, k1);
						end;
					end;
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if table.getn(moMapObjects.sr) > 0 and foundPalSammler < palSammler then
			for k, mapObject in pairs(moMapObjects.sr) do				
				if k ~= nil and mapObject.palX ~= nil and mapObject.palY ~= nil and mapObject.palZ ~= nil then
					local mx = mapObject.palX;
					local my = mapObject.palY;
					local mz = mapObject.palZ;
					checkSetPalSammler(moMapObjects.sr[k], mx, my, mz, 1);
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if table.getn(moMapObjects.ls) > 0 then --and foundPalSammler < table.getn(moMapObjects.palSammler) then
			for k, mapObject in pairs(moMapObjects.ls) do				
				if k ~= nil and mapObject.palX ~= nil and mapObject.palY ~= nil and mapObject.palZ ~= nil then
					local mx = mapObject.palX;
					local my = mapObject.palY;
					local mz = mapObject.palZ;
					checkSetPalSammler(moMapObjects.ls[k], mx, my, mz, 1);
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if foundPalSammler < palSammler then
			moGeneralSettings.notFoundPalSammler = palSammler-foundPalSammler;
		end;
	end;
	table.remove(moMapObjects.palSammler);
	if moGeneralSettings.wollPalCollector then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("wollPalCollector").. " ";end;
	if moGeneralSettings.palSammler then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("palSammler(").. tostring(palSammler).. ") ";end;
	if moGeneralSettings.watermod then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("watermod").. " ";end;
	if moGeneralSettings.viehmarkt then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("viehmarkt").. " ";end;
	if moGeneralSettings.gasStation then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("gasStation").. " ";end;
	if moGeneralSettings.allInOnSilo then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("allInOnSilo").. " ";end;
	if moGeneralSettings.fermentingSilo then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("fermentingSilo").. " ";end;
	if moGeneralSettings.mischStation then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("mischStation").. " ";end;
	if moGeneralSettings.mixFeeder then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("mixFeeder").. " ";end;
	if moGeneralSettings.upkReady then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("upk_universalProcessKit").. " ";end;	
end;